﻿Imports RCK02Net
'****************************************** HELP
'RCK1.P_ProgramID (e.g. "4AD14721F3698705BA618E2C" )
'   * Activation Key encryption logic will depend on this key
'   * ProgramID Must have 24 Characters
'   * All Characters of ProgramID Must be 0 To 9 OR 'A' To 'F'
'
'RCK1.P_Sequence (e.g. "ABCDEFGHIJKLMNOPQRSTUVWXYZ" this is default value)
'   * for advance protection use this property otherwise not require
'   * Sequence String length Must be 26 characters
'   * All characters must be between ('A' to 'Z') OR (0 to 9)
'   * No character must repeat
'   * Here output character Key(Activation Code Or MID Code) is map as "A as A,B as B,
'       C as C....as on Z as Z". you can change maping value as per your requirement
'   * E.g.
'          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
'          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQ123456789"
'          RCK1.P_Sequence = "ZYXWVUTSRQPONMLKJIHGFEDCBA"
'
'RCK1.P_SoftwareID (e.g. 1 is Default value)
'   *   If you have more than 1 software use this property(if you changed P_ProgramID in
'       all your softwares then you don't set this property)
'   * SoftwareID Must Be Between 1 To 26
'   * E.g.
'           RCK1.P_SoftwareID = 1 (For School Software)
'           RCK1.P_SoftwareID = 2 (For Account Software)
'           RCK1.P_SoftwareID = 3 (For Payslip)
'
'############### NOTE ################
'IN DEMO VERSION
'YOU CAN NOT CHANGE VALUE OF FOLLOWING PROPERTY. VALUE OF FOLLOWING PROPERTY IS READONLY IN DEMO VERSION
'   RCK1.P_ProgramID = "0123456789ABCDEF01234567"
'   RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
'   RCK1.P_SoftwareID = 1
'#####################################
Public Class FrmRegistrationForm
    Dim IsUnload As Boolean
    Dim ExtraCharFromAct As String = ""
    Dim mHardwarInfo As String

    Public Sub _Load()
        Try
            RCK1.Load_RCKProperty()

            MDLAct.AppStatus = -100  ' For application status is demo
            RCK1.P_ProgramID = "0123456789ABCDEF01234567"       ' Activation Key encryption logic will depend on this key
            RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"      ' enter Sequence charactors. output character Key(Activation Code Or MID Code) is map as "A as A,B as B,C as C....as on Z as Z" but you can change this sequence by this parameter (e.g. ABCDEFGHIJKLMNOPQ123456789 )
            RCK1.P_SoftwareID = 1  ' 1 For School Software, 2 For Account Software, 3 For Payslip ...As on

            Dim MIDCode As String = ""
            Dim ActivationCode As String
            Dim ExtraChar As String
            Dim ErrorNo As Integer

            Me.mHardwarInfo = GetHardwareInfo()
            ActivationCode = RCK1.M_GetActCode4FromRCKLIC4_DLL(My.Application.Info.DirectoryPath, 33)
            'Read Activation Code from (App.Path & "RCKLIC4.DLL")
            If ActivationCode <> "" Then
                Call CheckActivation(ActivationCode, False) ' Unprotect activation code
            End If
            '*** here we pass all hardware serial + other info to Mid Code
            ExtraChar = GetMIDCodeExtraChar()
            ErrorNo = RCK1.P_GetMID4(MIDCode, ExtraChar, 20)

            'Parameters description
            'MIDCode                -> Return MID Code (e.g. Return OKMYANSDWMLHFJNYSCLWNWXTOA )  
            '                          Here Mid code width is 26 (20 extra character+6 internal character) character
            'ExtraCharacter         -> Pass 20 characters of hardware Sr.no.+Other Character as per your requirement 
            'ExtraCharacterWidth    -> Pass With of ExtraCharacter(parameter) 
            '
            'this function return following error no
            'Return -1 For Width of ExtraChar(paramater) must be 20 character (as per ExtraCharacterWidth) 
            '       -2 For ExtraChar(parameter) value must be 'A' to 'Z'
            '        0 For MID Code created Success
            TxtMID.Text = PastDasIntoString(MIDCode, "2888") 'this function return (E.g. OK-MYANSDWM-LHFJNYSC-LWNWXTOA)

            If MDLAct.TempPer = 1 AndAlso Now.Date.AddDays(7) > MDLAct.DemoLastDate Then
                Me.Text &= " (Demo Over Date : " & Format(MDLAct.DemoLastDate, "dd-MM-yyyy") & ")"
                Dim lDif As Integer = DateDiff(DateInterval.Day, Now.Date, MDLAct.DemoLastDate)
                Me.Text &= " ( " & lDif.ToString.Trim & " Days Pending)"
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Function GetMIDCodeExtraChar() As String
        ' 1 To 15    -> Character Hardware Serial No
        ' 16 To 16   -> Software Type
        ' 17 To 20   -> Party Licence No
        '---------------------------------
        'Return Total 20 Character 
        '---------------------------------
        Dim lstr As String = ""
        '****** 1 Character To 15 Character FOR Hardware serial no
        lstr &= Me.mHardwarInfo ' 15 character
        '***** (16 char) FOR SOFTWARE TYPE - 1
        lstr &= NumToAbc(MDLAct.SoftType, 1)
        '***** (17 char -> 20 char) -4
        lstr &= NumToAbc(MDLAct.LicNo, 4)
        Return lstr
    End Function

    Private Sub FrmRegistrationForm_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        If IsUnload Then
            Me.Close()
        End If
    End Sub

    Private Sub CheckActivation(ByVal ActivationCode As String, ByVal IsDisplayMessage As Boolean)
        'this function unprotect activation code and match Hardware serial no to client PC
        'Parameter Description
        'ActivationCode     ->  Pass activation code
        'IsDisplayMessage   ->  Pass True for if you want to display error message

        Dim UniqueID As String = ""
        Dim SoftwareID As Integer
        Dim ExtraChar As String = ""
        Dim ErrorNo As Integer
        Dim IsCreateRCKLIC4_DLL As Boolean = True

        ErrorNo = RCK1.M_UnprotectAct4(ActivationCode, SoftwareID, ExtraChar, 26, My.Application.Info.DirectoryPath, IsCreateRCKLIC4_DLL)
        ' Activation Code width 26+7=33  character  (here extracharacter 26+internal character 7)

        'Parameters description
        'ActivationCode                    -> Pass Activation Code (e.g.HKQTUVP-AHODR-SDGUS-VQAVB-FNDTM)
        'SoftwareID                        -> Return Software ID
        'ExtraCharacter                    -> Return Extra 26 characters Which you have passed when
        '                                     activation code is generated(which contains hardware
        '                                     Sr.no of client PC as per your requirement+other character as per your requirement)
        'ExtraCharacterWidth               -> Pass ExtraCharacter Width (E.g. 26)
        'My.Application.Info.DirectoryPath -> Pass exe path (e.g. 'D:\School01') where it saves
        '                                     Activation Code in RCKLIC4.DLL file
        'IsCreateRCKLIC4_DLL               -> Pass True, if activation code successfully unprotect
        '                                     and then Activation code will save to (My.Application.Info.DirectoryPath & "RCKLIC4.DLL")
        '
        'Function return 0 For Activation Code unprotect Successfully

        If Me.mHardwarInfo <> Mid(ExtraChar, 1, 15) Then
            ErrorNo = -5
        End If

        If IsDisplayMessage Then
            Select Case ErrorNo
                Case -1
                    ' 33 character = (Extracharacter 26+Internal character 7)
                    MessageBox.Show("Width of Activation Code must be 33 characters", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Case -2
                    MessageBox.Show("Every character of activation Code must be between 'A' to 'Z'", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    'As per your RCK1.SequenceNo
                    '(e.g. if RCK1.SequenceNo = 'ABCDEFGHIJKLMNOP0123456789' then 'A' to 'P' OR 0 TO 9 )
                Case -3
                    MessageBox.Show("Invalid Activation Code(Typing mistake) or this Activation Code is not for this application ", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Case -4
                    'SoftwareID of Activation code is not match with SoftwareID of MID Code
                    MessageBox.Show("Invalid Activation Code (Error -4)", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Case -5
                    'Parameter -> ExtraCharacterWidth value must be 1 to 30"
                    MessageBox.Show("Invalid Activation Code (Error -5)", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Case -6
                    'Hardware Serial No of Activation Code does not match with Hardware Serial No of Client PC
                    MessageBox.Show("Invalid Activation Code (Error -6)", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Case 0
                    'MyMessageBox("Successs", MsgTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        '   AppStatus   -> 0            Activation Success (Registered copy)
        '   AppStatus   -> -1 to -6     error(Application status is Demo)
        '   AppStatus   -> -100         error(Application status is Demo)
        MDLAct.AppStatus = ErrorNo
        '***
        If ErrorNo = 0 Then
            'ExtraChar  -> Which contain following Information
            '              1 to 15 character    ->  hardware serial no  
            '              16 character         ->  software type
            '              17 to 18 character   ->  permanent activation or demo limit
            '              19 to 20 character   ->  module detail
            '              21 to 4 character    ->  party license no
            '              25 to 26 character   ->  total node (for Lan version)

            Dim lDec As Decimal
            '***** (16 CHAR)  FOR SOFTWARE TYPE
            lDec = AbcToNum(Mid(ExtraChar, 16, 1))
            If lDec >= 0 And lDec <= 4 Then
                MDLAct.SoftType = lDec
            End If
            '***** (17 CHAR -> 18 CHAR)  FOR PERMANENT ACTIVATION OR DEMO LIMIT
            lDec = AbcToNum(Mid(ExtraChar, 17, 2))
            If lDec = 0 Then
                MDLAct.TempPer = 2 'PERMANENT ACTIVATION CODE
                MDLAct.DemoLastDate = DateSerial(2013, 1, 1)
            Else
                MDLAct.TempPer = 1 'TEMPERAROR ACTIVATION CODE
                MDLAct.DemoLastDate = DateSerial(2013, 1, 1).AddDays(lDec * 15)
            End If
            '***** (19 CHAR -> 20 CHAR)  FOR MODULE
            Dim Char1 As String = DecToBin(AbcToNum(Mid(ExtraChar, 19, 1)), 4)
            Dim Char2 As String = DecToBin(AbcToNum(Mid(ExtraChar, 20, 1)), 4)
            MDLAct.Bin1Lan = IIf(Mid(Char1, 1, 1) = "1", True, False)
            MDLAct.Bin2SMS = IIf(Mid(Char1, 2, 1) = "1", True, False)
            MDLAct.Bin3Barcode = IIf(Mid(Char1, 3, 1) = "1", True, False)
            MDLAct.Bin4 = IIf(Mid(Char1, 4, 1) = "1", True, False)
            MDLAct.Bin5 = IIf(Mid(Char2, 1, 1) = "1", True, False)
            MDLAct.Bin6 = IIf(Mid(Char2, 2, 1) = "1", True, False)
            MDLAct.Bin7 = IIf(Mid(Char2, 3, 1) = "1", True, False)
            MDLAct.Bin8 = IIf(Mid(Char2, 4, 1) = "1", True, False)
            '***** (Start) License No (21 CHAR -> 24 CHAR) 4 
            MDLAct.LicNo = AbcToNum(Mid(ExtraChar, 21, 4))
            '***** (End) License No (21 CHAR -> 24 CHAR) 4 
            '***** (Start) Nodes (25 CHAR -> 26 CHAR) 2
            MDLAct.NodeTot = AbcToNum(Mid(ExtraChar, 25, 2))
            '***** (End) Nodes (25 CHAR -> 26 CHAR) 2
        End If
        If IsDisplayMessage Then
            If MDLAct.AppStatus = 0 Then
                MessageBox.Show("Success")
                RCK1.ResetMIDCode4()
            End If
        End If
    End Sub

    Private Function GetHardwareInfo() As String
        ' this function return hardware information
        ' Return (5 characters of Motherboard No)+(5 characters of HDD Serial No)+(5 characters of ProcessorID)+(5 characters of MAC Address),Total 20 characters return
        Dim ExtraCharacterPC
        ExtraCharacterPC = Microsoft.VisualBasic.Right(RCK1.M_GetMotherBoardSerialNo(), 5)
        ExtraCharacterPC = ExtraCharacterPC + Microsoft.VisualBasic.Right(RCK1.M_GetHDDDSerialNo(0, ""), 5)
        ExtraCharacterPC = ExtraCharacterPC + Microsoft.VisualBasic.Right(RCK1.M_GetProcessorId(), 5)
        ExtraCharacterPC = Microsoft.VisualBasic.Left(ExtraCharacterPC, 15) ' pass only 15 character
        Return ExtraCharacterPC
    End Function

    Private Sub CmdOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdOK.Click
        Call CheckActivation(TxtAct.Text, True)
        If MDLAct.AppStatus <> 0 Then
            Exit Sub
        End If
        Me.Close()
    End Sub

    Private Sub CmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdCancel.Click
        Me.Close()
    End Sub
End Class

